//XSETASETA@GMAIL.COM
//SETA43
// 15/06/2018
// 29/05/2023  SDL2
//

#include "ygrafi.h"



void refresco(void)
{
//    SDL_Flip(screen);
    SDL_UpdateWindowSurface(window);
}

//_____________________________________________

int init(int ancho,int alto)
{
    SCREEN_WIDTH = ancho; 
	SCREEN_HEIGHT = alto;

    if( SDL_Init(SDL_INIT_VIDEO) == -1 )  return 0;
    window = SDL_CreateWindow("SDL2", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, ancho, alto, 0);
    if (window == NULL) 	{	printf("Window could not be created:\n");	return 1;	}
    
    renderer = SDL_CreateRenderer(window, -1, 0);
    screen = SDL_GetWindowSurface(window);

    
    printf("Profundidad bit=%d  byte=%d\n",screen->format->BitsPerPixel,screen->format->BytesPerPixel);
    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) { printf("ERROR TTF_Init: \n"); return 0; }
		//Initialize SDL_mixer 
	if(SONIDO)if( Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 4096 ) == -1 )
		{
		 printf("Error SDL Mixer_Init:");
		 return 0;
		}

    return(1);
}

int load_files(char *f_fondo,char *f_imagenes,char *f_font)
{	
    SDL_Surface *temp1, *temp2, *temp3;
	if(f_fondo!=NULL)
		{
			background = load_image( (char*) f_fondo );
			if( background == NULL )  return 0;
		}
	if(f_imagenes!=NULL)
		{
			dots = load_image( (char*) f_imagenes );
            texture = SDL_CreateTextureFromSurface( renderer, dots );
			if( dots == NULL )  return 0;
		}
	if(f_font!=NULL)
		{
			font = TTF_OpenFont( (char*) f_font, 20 );
			if( font == NULL ) { printf("Error cargando Font\n"); return 0;	}	
		}
	
	return 1;
}



void clean_up()
{
	if(SONIDO)Mix_FreeChunk(sonido);
    SDL_FreeSurface( background );
	SDL_FreeSurface( dots );
    SDL_Quit();
}



SDL_Surface *load_image( char *filename )
{ 
	SDL_Surface *temp,*ima;

	temp  =IMG_Load(filename);
	if (temp == NULL){ printf("Error al cargar %s\n", filename); return 0;	}	
    if(window == NULL) return temp;
	ima = SDL_ConvertSurfaceFormat(temp, SDL_GetWindowPixelFormat(window), 0);
    SDL_FreeSurface(temp);
    
    if( ima != NULL )
        {
            SDL_SetColorKey( ima, SDL_TRUE, SDL_MapRGB( ima->format, 0, 0xFF, 0xFF ) );
			#ifdef DEBUG
				printf("ok al cargar %s\n", filename);
			#endif
        }
	return ima; 
}

void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, NULL, destination, &offset );
	}
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, clip, destination, &offset );
	}


//_________________PRIMITIVAS

void setcolor(unsigned char r,unsigned char g,unsigned char b)
{
	ColorDefault.r=r;	ColorDefault.g=g;	ColorDefault.b=b;
}

void plot(int x,int y) {putpixel(x,y,ColorDefault);}


/* ----- Imprime cuadrado ----- */
void box(int x,int y,int xx,int yy)
{
	//setcolor();
	if(x<0) x=0;
	if(xx<0) xx=0;
	if(y<0) y=0;
	if(yy<0) yy=0;
	line(x,y,xx,y);
	line(xx,y,xx,yy);
	line(xx,yy,x,yy);
	line(x,yy,x,y);
}


/* ----- Imprime cuadrado relleno----- */
void bar(int x,int y,int xx,int yy)
{
int  d,d2; 
unsigned  int c,cc,z,z1,zz,tt;
int Walto=screen->h;
int Wancho=screen->w;

	if(x>xx){d=x; x=xx; xx=d;}
  	if(y>yy){d=y; y=yy; yy=d;}
//	setcolor();

       if(x<0)x=0;
       if(xx<0)xx=0;
       if(y<0)y=0;
       if(yy<0)yy=0;
       if(x>=Wancho)x=Wancho-1;
       if(xx>=Wancho)xx=Wancho-1;
       if(y>=Walto)y=Walto-1;
       if(yy>=Walto)yy=Walto-1;
       for(zz=y;zz<yy;zz++) line(x,zz,xx,zz);
}



/* ----- IMPRIME LINEA ------------ */
void line(int x,int y,int xx,int yy)
{
 unsigned short int z,c,a,vx,vy;
 int Walto=screen->h;
 int Wancho=screen->w;

                 if(x==xx)
	                {
                         if(y>yy){z=y;y=yy;yy=z;}
                         if(y<0) y=0;
                         if(yy>Walto)yy=Walto;
                         for(;y<=yy;y++)plot(x,y);
                         goto fin;
                        }

                 if(y==yy)
                    	{
                         if(x>xx){z=x;x=xx;xx=z;}
                         if(x<0)x=0;
                         if(xx>Wancho)xx=Wancho;
                         for(;x<=xx;x++)plot(x,y);
                         goto fin;
                        }                       
                 if(x<xx)
					{
                    if(y<yy)
                     goto normal;
                    else
                     goto nonormal;
                    }
                    else
                    {
                    if(y>yy)
                       {    z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto normal;  }
                       else
                       {    z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto nonormal;  }
                    }
nonormal:
   		 vx=xx-x; vy=y-yy;a=0;
                 plot(xx,yy);
                 if(vx>vy)
                   {
                    c=vx;
                    while(c>0)
						{
							c--;xx--;a+=vy;
							if(a>=vx){a-=vx; yy++;}
							plot(xx,yy);
						}
                   }
                     else
                   {
                    c=vy;
                    while(c>0)
						{
							c--;yy++;a+=vx;
							if(a>=vy){a-=vy;xx--;}
							plot(xx,yy);
						}
                   }
                 goto fin;
normal:
   		 vx=xx-x;vy=yy-y;a=0;
                 plot(x,y);
                 if(vx>vy)
                 {
                  c=vx;
                  while(c>0)
						{
							c--; x++; a=a+vy;
							if(a>=vx){ a-=vx; y++; }
							plot(x,y);
						}
                 }
				else
                 {
                  c=vy;
                  while(c>0)
                     {
						c--; y++; a=a+vx;
						if(a>=vy){ a-=vy; x++; }
						plot(x,y);
                     }
                 }
	fin:
	;
}



void putpixel(int x,int y,SDL_Color color)
{	
	unsigned int col=SDL_MapRGB(screen->format,color.r,color.g,color.b);	
	char *buffer=(char*) screen->pixels;
	buffer+=screen->pitch*y;
	buffer+=screen->format->BytesPerPixel*x;
	char *direccolor=(char*) &col;
	switch (screen->format->BytesPerPixel)			
			{	
				case 4:
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
				break;	
				case 3:
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
				break;						
				case 2:
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
				break;
				case 1:
					*(buffer++)=*(direccolor++);
				break;				
			}
}	
